create table YPOLPANALITEOS
(
  AUTHID VARCHAR2(40),
  RNEOS  NUMBER(17)
);
create index IDX_YPOLPANALITEOS_1 on YPOLPANALITEOS (AUTHID, RNEOS);
grant select on YPOLPANALITEOS to PUBLIC;

create or replace view v_eopanaliz_olapyp2 as
select
     DB.Acc_Number as account_debit,
     KR.Acc_Number as account_credit,
     DB_AN1.ANL_NUMBER AS analytic_debit1,
     DB_AN2.ANL_NUMBER AS analytic_debit2,
     DB_AN3.ANL_NUMBER AS analytic_debit3,
     DB_AN4.ANL_NUMBER AS analytic_debit4,
     DB_AN5.ANL_NUMBER AS analytic_debit5,
     KR_AN1.ANL_NUMBER AS analytic_credit1,
     KR_AN2.ANL_NUMBER AS analytic_credit2,
     KR_AN3.ANL_NUMBER AS analytic_credit3,
     KR_AN4.ANL_NUMBER AS analytic_credit4,
     KR_AN5.ANL_NUMBER AS analytic_credit5,
     d_year(s.operation_date) as nYEAR,
     d_month(s.operation_date) as nMONTH,
     j.CODE AS sjur_pers,
     substr(nvl(DB.ACC_NUMBER,kr.Acc_Number),1,1) as sVFO,
     sum(s.acnt_sum) as acnt_sum
from YPOLPANALITEOS T,
     OPRSPECS S,
     JURPERSONS J,
     DICACCS DB,
     DICACCS KR,
     DICANLS DB_AN1,
     DICANLS DB_AN2,
     DICANLS DB_AN3,
     DICANLS DB_AN4,
     DICANLS DB_AN5,
     DICANLS KR_AN1,
     DICANLS KR_AN2,
     DICANLS KR_AN3,
     DICANLS KR_AN4,
     DICANLS KR_AN5
where T.AUTHID = user
  and T.RNEOS = S.rn
  and S.JUR_PERS = J.RN
  and S.ACCOUNT_DEBIT = DB.RN(+)
  and S.Account_Credit = KR.RN(+)
  and S.Analytic_Debit1 = DB_AN1.rn(+)
  and S.Analytic_Debit2 = DB_AN2.rn(+)
  and S.Analytic_Debit3 = DB_AN3.rn(+)
  and S.Analytic_Debit4 = DB_AN4.rn(+)
  and S.Analytic_Debit5 = DB_AN5.rn(+)
  and S.Analytic_Credit1 = KR_AN1.rn(+)
  and S.Analytic_Credit2 = KR_AN2.rn(+)
  and S.Analytic_Credit3 = KR_AN3.rn(+)
  and S.Analytic_Credit4 = KR_AN4.rn(+)
  and S.Analytic_Credit5 = KR_AN5.rn(+)
group by DB.ACC_NUMBER,
         KR.ACC_NUMBER,
         DB_AN1.ANL_NUMBER,
         DB_AN2.ANL_NUMBER,
         DB_AN3.ANL_NUMBER,
         DB_AN4.ANL_NUMBER,
         DB_AN5.ANL_NUMBER,
         KR_AN1.ANL_NUMBER,
         KR_AN2.ANL_NUMBER,
         KR_AN3.ANL_NUMBER,
         KR_AN4.ANL_NUMBER,
         KR_AN5.ANL_NUMBER,
         d_year(s.operation_date),
         d_month(s.operation_date),
         j.CODE,
         substr(nvl(DB.ACC_NUMBER,kr.Acc_Number),1,1)
/
grant select on V_EOPANALIZ_OLAPYP2 to PUBLIC;

create or replace procedure P_EOPANALIZ_OLAPYP(nCompany  in number,
                                               dDateFrom in date,
                                               dDateTo   in date,
                                               sJur_Pers  in varchar2,
                                               sACC_DB   in varchar2,
                                               sACC_CR   in varchar2)
as

  sSQL         PKG_STD.tSQL ;


  procedure PREPARE_PKG_CONDITIONS
  as
  begin
    PKG_CONDITIONS.CONSTRUCTOR(nCOMPANY);
    PKG_CONDITIONS.table_found := 1;
    PKG_CONDITIONS.select_count := 1;
    PKG_CONDITIONS.request_string := null;
    PKG_CONDITIONS.is_where := true;
    PKG_CONDITIONS.read_request := false;
  end PREPARE_PKG_CONDITIONS;


  procedure P_CONCATE_FIELD
  (
    conc_action      in varchar2, /*      */
    comp_action      in varchar2, /*     */
    sub_table        in varchar2, /*   */
    sub_cond         in varchar2, /*    */
    sub_select       in varchar2, /*    */
    field_name       in varchar2, /*    */
    value_type       in integer,  /*  : 0 -number, 1-varchar, 2-date */
    field_value      in varchar2, /*     */
    replace_options  in boolean,  /*      */
    out_request      in out varchar2
  )
  as
  begin
    PREPARE_PKG_CONDITIONS;
    PKG_CONDITIONS.P_CONCATE_FIELD(conc_action, comp_action, sub_table, sub_cond,
      sub_select, field_name, value_type, field_value, replace_options, out_request);
    PKG_CONDITIONS.DESTRUCTOR;
  exception
    when OTHERS then
      PKG_CONDITIONS.DESTRUCTOR;
      raise;
  end P_CONCATE_FIELD;

  procedure MAKE_JUR_LIST
  (
    sJUR_CODE       in varchar2
  )
  as
    sSQL            PKG_STD.tSQL;
    sADD_COND       PKG_STD.tSQL;
    aCURSOR         PKG_CURSORS.CurType;
    nWCHILD         number(1) := 1;
    nJUR_RN         PKG_STD.tREF;
    nCOMPANY1       PKG_STD.tREF := nCOMPANY;

    /*     */
    procedure IDLIST_INSERT
    (
      nRN           in number
    )
    as
      nTMP          PKG_STD.tREF;
    begin
      begin
        select ID
        into nTMP
        from IDLIST
        where ID = nRN;
      exception
        when NO_DATA_FOUND then
        insert into IDLIST( ID ) values ( nRN );
      end;
    end IDLIST_INSERT;

  begin
    if rtrim(sJUR_CODE) is not null then
      --   
      delete from IDLIST;
      --  
      sSQL := 'select nRN from V_JURPERSONS where nCOMPANY = :nCOMPANY1';
      P_CONCATE_FIELD( ' and ', '=',  null, null, null, 'sCODE', 1, sJUR_CODE, true, sADD_COND );
      sSQL := sSQL||sADD_COND;
      begin
        open aCURSOR for sSQL using nCOMPANY1;
        loop
          fetch aCURSOR into nJUR_RN;
          exit when aCURSOR%notfound;

          --  
          if nWCHILD = 1 then
             for jur in
             (
               select nRN from V_JURPERSONS
               where ncompany = nCOMPANY1
               start with nRN = nJUR_RN connect by prior nRN = nPRN
             )
             loop
               --    
               IDLIST_INSERT(jur.nRN);
             end loop; -- jur
          --  
          else
            --    
            IDLIST_INSERT(nJUR_RN);
          end if;
        end loop; -- aCURSOR
        close aCURSOR;
      exception
        when OTHERS then
          close aCURSOR;
          raise;
      end;

      begin
        select ID
        into nJUR_RN
        from IDLIST;
      exception
        when NO_DATA_FOUND or TOO_MANY_ROWS then
          /*   */
          --FIND_JURPERSONS_MAIN( 0, nCOMPANY, sJUR_CODE_TMP, nJUR_RN );
         null;
      end;

    else
      insert into IDLIST( ID ) (select nRN from V_JURPERSONS z  where z.ncompany = nCOMPANY1);
    end if;
  end MAKE_JUR_LIST;
begin

    MAKE_JUR_LIST(sJUR_PERS);

    PKG_COND_BROKER.PROLOGUE;

    sSQL := 'SELECT  a.rn  ,      '||CR||
            '        a.ACCOUNT_DEBIT   as DB,   '||CR||
            '        a.ACCOUNT_CREDIT  as CR    '||CR||
            'FROM    oprspecs a   '||CR||
            'WHERE   a.OPERATION_DATE between :DATE_PRM1 and :DATE_PRM2 '||CR||
            '  and   a.jur_pers in (select id from idlist)';

    PKG_COND_BROKER.SET_TABLE( '('||sSQL||')' );
    PKG_COND_BROKER.BIND_VARIABLE( 'DATE_PRM1',dDateFrom);
    PKG_COND_BROKER.BIND_VARIABLE( 'DATE_PRM2',dDateTo);
    if sACC_DB is not null then
       PKG_COND_BROKER.ADD_CODE( 'ACC_NUMBER',sACC_DB,'DB <- RN;DICACCS' );
    end if;
    if sACC_CR is not null then
       PKG_COND_BROKER.ADD_CODE( 'ACC_NUMBER',sACC_CR,'CR <- RN;DICACCS' );
    end if;
    -- 
    PKG_COND_BROKER.EPILOGUE;

    delete from YPOLPANALITEOS t
    where t.authid = user;

    insert into YPOLPANALITEOS(AUTHID,RNEOS)  (select user as AUTHID, id as RNEOS from COND_BROKER_IDLITE);

    commit;



end;
/
grant execute on P_EOPANALIZ_OLAPYP to PUBLIC;
show errors procedure P_EOPANALIZ_OLAPYP;